var inStr = ""; // Строка имитирующая входную ленту (данные из формы)
var erStr = ""; // Строка с сообщением о результатах разбора
var i = 10;  // Текущее положение входной головки
var erFlag = -1; // Флаг, фиксирующий наличие ошибок в середине правила

// Функция, реализующая чтение символов в буфер из поля формы.
function GetLine() {
    var bracketsInput = document.getElementById("bracketsInput");
    inStr = bracketsInput.value + "\n";
}

// Функция, реализующая распознавание нетерминала S.
function S() {
    var state = 0;
    while(state !== 999) {
        switch(state) {
            case 0:     // Точка 0 диаграммы
                if(inStr[i] == '(') {
                    i++;
                    state = 1;
                    continue;
                }
                return false;// Первый символ цепочки некорректен
                             // что это ошибка, лучше определить снаружи
            case 1:     // Точка 1 диаграммы
                if(inStr[i] == ')') {
                    i++;
                    state = 3;
                    continue;
                }
                if(S()) {
                    state = 2;
                    continue;
                }
                erFlag++;
                erStr += "<br>Position " + i + ", " + "Error 1: I want closed bracket or next opened bracket!";
                return false;
            case 2:     // Точка 2 диаграммы
                if(inStr[i] == ')') {
                    i++;
                    state = 3;
                    continue;
                }
                erFlag++;
                erStr += "<br>Position " + i + ", " + "Error 2: I want closed bracket!";
                return false;
            case 3:     // Точка 3 диаграммы
                if(inStr[i] == '(') {
                    i++;
                    state = 1;
                    continue;
                }
                state = 999;
                break;
        }
    }
    // Выход по 999.
	return true;
}

// Функция, реализующая распознавание нетерминала Z
// В связи с отсутствием goto в JavaScript
// используется switch технология автоматного программирования
function Z() {
    //
    var state = 0;
    while(state !== 999) {
        switch(state) {
            case 0:     // Точка 0 диаграммы
                if(S()) {
                    state = 1;
                    continue;
                }
                return false;   // Первый символ цепочки некорректен
                                // что это ошибка, лучше определить снаружи
                break;
            case 1:     // Точка 1 диаграммы
                // За последней скобкой должен быть "конец строки"
                if(inStr[i] == '\n') {
                    state = 999; // Все прошло нормально
                    continue;
                }
                // Сообщение об ошибке
                erFlag++;
                erStr += "<br>Position " + i + ", " +"Error 3: I want end of line!";
                return false;
        }
    }
    // Выход по 999.
    return true;
}


function Parser() {
    // Начальная инициализация.
    erFlag = 0;
    i = 0;

    // Процесс пошел!
    if(Z()) { 
        return true; // Все прошло нормально
    }
    else {
        if(erFlag) {
            erStr += "<br>Position " + i + ", " + "Error 7: Internal Error!";
        }
        else {
            erStr = "<br>Position " + i + ", " + "Error 8: Incorrect first symbol of S!";
        }
        return false; // Есть ошибки
    }
}

// Вспомогательная функция, осуществляющая повторение строки ch k раз.
function Repeat(k, ch) {
    var s = "";
    for(i = 0; i < k; i++) {
        s += ch;
    }
    return s;
}

// event handlers

// Функция запускающая парсер и осуществляющая вывод результатов разбора
function handleParseButton() {

    // Очистка буфера сообщений об ошибках
    erStr = "";
    // Чтение строки из формы в буфер для разбора
    GetLine();
    
    var rezStr = "";
    // Здесь начинается разбор принятой строки.
    if(Parser()) {
        rezStr = "+++++ OK! +++++";
    }
    else {
        rezStr = "----- Fatal error (look upper error message)! -----";
    }

    // Вывод разобранной строки и значения позиции входой головки.
    var mesStr = "Line: " + inStr;
    var strCursor = " Pos: " + Repeat(i, "-") + "^" + "  i = " + i;
    
    // Вывод сообщения о результатах разбора
    var messageField = document.getElementById("messageField");
    messageField.innerHTML = rezStr;

    // Вывод разобранного скобочного выражения
    var bracketsField = document.getElementById("bracketsField");
    bracketsField.innerHTML = mesStr;

    // Вывод позиции входной головки в момент окончания разбора
    var cursorField = document.getElementById("cursorField");
    cursorField.innerHTML = strCursor;

    // Вывод накопленных сообщений об ошибках к моменту окончания разбора
    var errorsField = document.getElementById("errorsField");
    errorsField.innerHTML = erStr;

}

function handleKeyPress(e) {
    var parseButton = document.getElementById("parseButton");

    // in IE9 and earlier, the event object doesn't get passed
    // to the event handler correctly, so we use window.event instead.
    e = e || window.event;
    
    if (e.keyCode === 13) {
        parseButton.click();
        return false;
    }
}


// init - called when the page has completed loading
window.onload = init;

function init() {
    // Parse button onclick handler
    var parseButton = document.getElementById("parseButton");
    parseButton.onclick = handleParseButton;

    // handle "return" key press
    var bracketsInput = document.getElementById("bracketsInput");
    bracketsInput.onkeypress = handleKeyPress;
}


